/*
 * DesktopApplication1View.java
 */

package jfileaid;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import org.jdesktop.application.Action;
//import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
//import org.jdesktop.application.TaskMonitor;
//import java.awt.event.ActionEvent;
//import java.awt.event.ActionListener;
import java.io.File;
//import javax.swing.Timer;
//import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.KeyStroke;
import org.nla.cobol.CobolCopyBookLineMapping;
import org.nla.cobol.CobolCopyBookParser;
import org.nla.cobol.CobolFile;
import org.nla.cobol.CopyFileMapper;

/**
 * The application's main frame.
 */
public class JFileAidView extends FrameView {

    protected int currentLineMapped = 1;

    public JFileAidView(SingleFrameApplication app) {
        super(app);

        initComponents();

        // status bar initialization - message timeout, idle icon and busy animation, etc
        /*
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }
        });
        */
    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = JFileAid.getApplication().getMainFrame();
            aboutBox = new JFileAidAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        JFileAid.getApplication().show(aboutBox);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        txtLineMapped = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        btnPrevious = new javax.swing.JButton();
        btnNext = new javax.swing.JButton();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        loadCopyBookItem = new javax.swing.JMenuItem();
        mapToCobolFileItem = new javax.swing.JMenuItem();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        editMenu = new javax.swing.JMenu();
        hexaItem = new javax.swing.JCheckBoxMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        fileChooser = new javax.swing.JFileChooser();

        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                mainPanelKeyPressed(evt);
            }
        });

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jTable1.setCellSelectionEnabled(true);
        jTable1.setName("jTable1"); // NOI18N
        jTable1.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                jTable1InputMethodTextChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);
        jTable1.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(jfileaid.JFileAid.class).getContext().getResourceMap(JFileAidView.class);
        txtLineMapped.setText(resourceMap.getString("txtLineMapped.text")); // NOI18N
        txtLineMapped.setEnabled(false);
        txtLineMapped.setName("txtLineMapped"); // NOI18N
        txtLineMapped.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                txtLineMappedFocusLost(evt);
            }
        });

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setEnabled(false);
        jLabel1.setName("jLabel1"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(jfileaid.JFileAid.class).getContext().getActionMap(JFileAidView.class, this);
        btnPrevious.setAction(actionMap.get("loadPreviousLine")); // NOI18N
        btnPrevious.setText(resourceMap.getString("btnPrevious.text")); // NOI18N
        btnPrevious.setToolTipText(resourceMap.getString("btnPrevious.toolTipText")); // NOI18N
        btnPrevious.setEnabled(false);
        btnPrevious.setName("btnPrevious"); // NOI18N

        btnNext.setAction(actionMap.get("loadNextLine")); // NOI18N
        btnNext.setText(resourceMap.getString("btnNext.text")); // NOI18N
        btnNext.setToolTipText(resourceMap.getString("btnNext.toolTipText")); // NOI18N
        btnNext.setEnabled(false);
        btnNext.setName("btnNext"); // NOI18N

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 734, Short.MAX_VALUE)
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addGap(106, 106, 106)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(txtLineMapped, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(30, 30, 30)
                        .addComponent(btnPrevious)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnNext)))
                .addContainerGap())
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 361, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtLineMapped, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnNext)
                    .addComponent(btnPrevious)
                    .addComponent(jLabel1))
                .addContainerGap(21, Short.MAX_VALUE))
        );

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        loadCopyBookItem.setAction(actionMap.get("loadCopyBook")); // NOI18N
        loadCopyBookItem.setText(resourceMap.getString("loadCopyBookItem.text")); // NOI18N
        loadCopyBookItem.setName("loadCopyBookItem"); // NOI18N
        loadCopyBookItem.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                loadCopyBookItemMouseClicked(evt);
            }
        });
        fileMenu.add(loadCopyBookItem);

        mapToCobolFileItem.setAction(actionMap.get("mapToCobolFile")); // NOI18N
        mapToCobolFileItem.setText(resourceMap.getString("mapToCobolFileItem.text")); // NOI18N
        mapToCobolFileItem.setEnabled(false);
        mapToCobolFileItem.setName("mapToCobolFileItem"); // NOI18N
        fileMenu.add(mapToCobolFileItem);

        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        editMenu.setText(resourceMap.getString("editMenu.text")); // NOI18N
        editMenu.setName("editMenu"); // NOI18N

        hexaItem.setAction(actionMap.get("setHexView")); // NOI18N
        hexaItem.setText(resourceMap.getString("hexaItem.text")); // NOI18N
        hexaItem.setEnabled(false);
        hexaItem.setName("hexaItem"); // NOI18N
        editMenu.add(hexaItem);

        menuBar.add(editMenu);

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        fileChooser.setDialogTitle(resourceMap.getString("fileChooser.dialogTitle")); // NOI18N
        fileChooser.setName("fileChooser"); // NOI18N

        setComponent(mainPanel);
        setMenuBar(menuBar);
    }// </editor-fold>//GEN-END:initComponents
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_exitMenuItemActionPerformed

    private void loadCopyBookItemMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_loadCopyBookItemMouseClicked
        fileChooser.showOpenDialog(jTable1);
    }//GEN-LAST:event_loadCopyBookItemMouseClicked

    private void txtLineMappedFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtLineMappedFocusLost
        try {
            int intTxtLine = Integer.parseInt( txtLineMapped.getText() );
            currentLineMapped = intTxtLine;
            loadMappedContentIntoTable(false);
            refreshButtonStates();
        }
        catch(Exception e){
            txtLineMapped.setText(currentLineMapped+"");
        }
    }//GEN-LAST:event_txtLineMappedFocusLost

    private void jTable1InputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_jTable1InputMethodTextChanged
        // TODO add your handling code here:
        System.out.println("je passe ici");
    }//GEN-LAST:event_jTable1InputMethodTextChanged

    private void mainPanelKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_mainPanelKeyPressed
        // TODO add your handling code here:
    }//GEN-LAST:event_mainPanelKeyPressed

    @Action
    public void loadCopyBook() {
        int option = fileChooser.showOpenDialog(jScrollPane1);
        
        if ( option == JFileChooser.APPROVE_OPTION ) {
            File file = fileChooser.getSelectedFile();
            try {
                JFileAid.getApplication().copyBook = CobolCopyBookParser.buildCopyBook( file.getAbsolutePath() );
                loadCopyBookStructureIntoTable();
                mapToCobolFileItem.setEnabled(true);
            }
            catch( Exception e ) {
                e.printStackTrace();
            }
        }

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnNext;
    private javax.swing.JButton btnPrevious;
    private javax.swing.JMenu editMenu;
    private javax.swing.JFileChooser fileChooser;
    private javax.swing.JCheckBoxMenuItem hexaItem;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JMenuItem loadCopyBookItem;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuItem mapToCobolFileItem;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JTextField txtLineMapped;
    // End of variables declaration//GEN-END:variables

    //private final Timer messageTimer;
    //private final Timer busyIconTimer;
    //private final Icon idleIcon;
    //private final Icon[] busyIcons = new Icon[15];
    //private int busyIconIndex = 0;

    private JDialog aboutBox;

    private void loadCopyBookStructureIntoTable() {
        //throw new UnsupportedOperationException("Not yet implemented");
        jTable1.setModel( new CobolTableModel(JFileAid.getApplication().copyBook)  );

        // set up column widths
        jTable1.getColumnModel().getColumn(0).setPreferredWidth(200);
        jTable1.getColumnModel().getColumn(1).setPreferredWidth(20);
        jTable1.getColumnModel().getColumn(2).setPreferredWidth(30);
        jTable1.getColumnModel().getColumn(3).setPreferredWidth(30);
        jTable1.getColumnModel().getColumn(4).setPreferredWidth(30);

        mapToCobolFileItem.setEnabled(true);



    // Disable auto resizing
    //table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

    // Set the first visible column to 100 pixels wide
    //int vColIndex = 0;
    //TableColumn col = table.getColumnModel().getColumn(vColIndex);
    //int width = 100;
    //col.setPreferredWidth(width);




    }

    @Action
    public void mapToCobolFile() {

        int option = fileChooser.showOpenDialog(jScrollPane1);

        if ( option == JFileChooser.APPROVE_OPTION ) {
            File file = fileChooser.getSelectedFile();
            try {
                JFileAid.getApplication().cobolFile = new CobolFile( file.getAbsolutePath(), true );
                JFileAid.getApplication().mapper = new CopyFileMapper(JFileAid.getApplication().cobolFile, JFileAid.getApplication().copyBook);
                currentLineMapped = 1;
                loadMappedContentIntoTable(true);
                btnNext.setEnabled(true);
                jLabel1.setEnabled(true);
                txtLineMapped.setEnabled(true);
                hexaItem.setEnabled(true);
                hexaItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H, ActionEvent.ALT_MASK));

            }
            catch( Exception e ) {
                e.printStackTrace();
            }
        }
    }

    public void loadMappedContentIntoTable(boolean resize) {
        txtLineMapped.setText(""+ currentLineMapped);
        CobolCopyBookLineMapping mapping = JFileAid.getApplication().mapper.mapFileLineToCopyBook(currentLineMapped);
        
        CobolTableModel model = new CobolTableModel(mapping);
        model.setHexView( hexaItem.isSelected() );

        jTable1.setModel( model );

        // set up column widths
        if (true) {
        jTable1.getColumnModel().getColumn(0).setPreferredWidth(200);
        jTable1.getColumnModel().getColumn(0).setMinWidth(200);
        jTable1.getColumnModel().getColumn(1).setMaxWidth(90);
        jTable1.getColumnModel().getColumn(2).setMaxWidth(60);
        jTable1.getColumnModel().getColumn(3).setMaxWidth(60);
        jTable1.getColumnModel().getColumn(4).setMaxWidth(60);
        //jTable1.getColumnModel().getColumn(4).setPreferredWidth(30);
        }

    }

    @Action
    public void loadPreviousLine() {
        if ( currentLineMapped > 1 ) {
            currentLineMapped -= 1;
        }

        loadMappedContentIntoTable(false);
        refreshButtonStates();
    }

    @Action
    public void loadNextLine() {
        if ( currentLineMapped < JFileAid.getApplication().cobolFile.getLineCount() ) {
            currentLineMapped += 1;
        }

        loadMappedContentIntoTable(false);
        refreshButtonStates();
    }

    protected void refreshButtonStates() {
        if ( currentLineMapped == 0 ) {
            btnNext.setEnabled(true);
            btnPrevious.setEnabled(false);
        }

        else if ( currentLineMapped > 0 && currentLineMapped < JFileAid.getApplication().cobolFile.getLineCount() ) {
            btnNext.setEnabled(true);
            btnPrevious.setEnabled(true);
        }

        else if ( currentLineMapped == JFileAid.getApplication().cobolFile.getLineCount() ) {
            btnNext.setEnabled(false);
            btnPrevious.setEnabled(true);
        }
    }

    @Action
    public void setHexView() {
        loadMappedContentIntoTable(false);
    }
}
