package org.nla.cobol;

import java.io.*;
import java.util.*;

public class CobolFile {

	protected File _file;
	protected long _lngLength;
	protected int _intCurrentPosition;
	
	protected List<String> _lstLines;
	
	protected boolean _blnFileToLoad;
	
	
	
	
	public CobolFile( String strFilePath, boolean blnFileToLoad/*, long lngLength*/ ) throws IOException {
		_file = new File( strFilePath );
		_blnFileToLoad = blnFileToLoad;
		//_lngLength = lngLength;
		_loadFileLines();
		_intCurrentPosition = 0;
	}
	
	public void _loadFileLines() throws IOException {
		_lstLines = new ArrayList<String>();
		
		BufferedReader buf = new BufferedReader( new FileReader( _file ) );
		for( String strLine = buf.readLine(); strLine != null; strLine = buf.readLine() ) {
			_lstLines.add( strLine );
		}
	}
	
	public String getCurrentLine() {
		return _lstLines.get( _intCurrentPosition );
	}
	
	public String getNextLine() {
		_intCurrentPosition += 1;
		return getCurrentLine();
	}

	public String getPreviousLine() {
		_intCurrentPosition -= 1;
		return getCurrentLine();
	}
	
	
	public int getCurrentPosition() {
		return _intCurrentPosition + 1;
	}
	
	public int getLineCount() {
		return _lstLines.size();
	}

	public void setCurrentPosition(int currentPosition) {
		if ( currentPosition < 1 || currentPosition > _lstLines.size() )  {
			throw ( new IllegalArgumentException( "CobolFile::setCurrentPosition(int) incorrect currentPosition " + currentPosition ) );
		}
		_intCurrentPosition = currentPosition - 1;
	}

	public static void main(String[] args) {
		
		try {
			CobolFile cf = new CobolFile( "copy.txt", true );
			System.out.println( cf.getCurrentLine() );
			cf.setCurrentPosition(5);
			System.out.println( cf.getCurrentLine() );
			cf.setCurrentPosition(5555);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}

	

